/*
 Example sketch for the PS3 USB library - developed by Kristian Lauszus
 For more information visit my blog: http://blog.tkjelectronics.dk/ or 
 send me an e-mail:  kristianl@tkjelectronics.com
 */
#include <IRremote.h>
 //int RECV_PIN=2;
 //IRrecv irrecv(RECV_PIN);
 IRsend irsend;
 
#define IR_T 0x2C9B      // T
#define IR_W 0x6C9B      // W
#define IR_PHOTO 0x8CBC0  // Photo
#define IR_REC 0xCBC0    // Rec/StopRec

int status_rec=0;


#include <PS3USB.h>
USB Usb;
/* You can create the instance of the class in two ways */
PS3USB PS3(&Usb); // This will just create the instance
//PS3USB PS3(&Usb,0x00,0x15,0x83,0x3D,0x0A,0x57); // This will also store the bluetooth address - this can be obtained from the dongle when running the sketch

boolean printAngle;
uint8_t state = 0;

int status_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
long millis_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

void setup() {
  Serial.begin(115200);
  if (Usb.Init() == -1) {
    Serial.print(F("\r\nOSC did not start"));
    while(1); //halt
  }  
  Serial.print(F("\r\nPS3 USB Library Started"));
}
void loop() {
  Usb.Task();

  if(PS3.PS3Connected || PS3.PS3NavigationConnected) {
    if(PS3.getAnalogHat(LeftHatX) > 137 || PS3.getAnalogHat(LeftHatX) < 117 || PS3.getAnalogHat(LeftHatY) > 137 || PS3.getAnalogHat(LeftHatY) < 117 || PS3.getAnalogHat(RightHatX) > 137 || PS3.getAnalogHat(RightHatX) < 117 || PS3.getAnalogHat(RightHatY) > 137 || PS3.getAnalogHat(RightHatY) < 117) {
     Serial.print(F("\r\nLeftHatX: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatX));
      Serial.print(F("\tLeftHatY: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatY));
      if(!PS3.PS3NavigationConnected) {
        Serial.print(F("\tRightHatX: ")); 
        Serial.print(PS3.getAnalogHat(RightHatX));
        Serial.print(F("\tRightHatY: ")); 
        Serial.print(PS3.getAnalogHat(RightHatY));
       } 
    //delay(200);   
    }
    // Analog button values can be read from almost all buttons
    /*if(PS3.getAnalogButton(L2) || PS3.getAnalogButton(R2)) {
      Serial.print(F("\r\nL2: ")); 
      Serial.print(PS3.getAnalogButton(L2));
      if(!PS3.PS3NavigationConnected) {
        Serial.print(F("\tR2: ")); 
        Serial.print(PS3.getAnalogButton(R2));
      } 
    }*/


    if(PS3.getButtonClick(PS))
      Serial.print(F("\r\nPS"));

    if(PS3.getButtonClick(TRIANGLE)){
      Serial.print(F("\r\nRight1"));
      irsend.sendSony(IR_PHOTO,20);
      } 
   if(PS3.getButtonClick(CIRCLE))
      Serial.print(F("\r\nRight14"));
    if(PS3.getButtonClick(CROSS)){
      Serial.print(F("\r\nRight12"));
      irsend.sendSony(IR_REC,20);
      status_rec=1-status_rec;
      if(status_rec==1) PS3.setLedOn(LED3);
      else PS3.setLedOff(LED3);
      } 
   if(PS3.getButtonClick(SQUARE))
      Serial.print(F("\r\nRight13"));

    if(PS3.getButtonPress(UP)) {
      Serial.print(F("\r\nUp"));
      PS3.setLedOn(LED1);
      irsend.sendSony(IR_T,20);
    } 
    if(PS3.getButtonPress(RIGHT)) {
      Serial.print(F("\r\nRight"));
      PS3.setLedOn(LED2);
     } 
    if(PS3.getButtonPress(DOWN)) {
      Serial.print(F("\r\nDown"));
      PS3.setLedOn(LED3);
      irsend.sendSony(IR_W,20);
      } 
    if(PS3.getButtonPress(LEFT)) {          
      Serial.print(F("\r\nLeft"));
      PS3.setLedOn(LED4);                   
    } 

    if(PS3.getButtonPress(L1) && status_buttons[L1]==0)
      {Serial.print(F("\r\nL1"));millis_buttons[L1]=millis();status_buttons[L1]=1;} 
    else 
      {if(millis()-millis_buttons[L1]>3000) status_buttons[L1]=0;} 
    if(PS3.getButtonPress(R1))
      Serial.print(F("\r\nR1"));  
    if(PS3.getButtonPress(L2))
      Serial.print(F("\r\nL2"));
    if(PS3.getButtonPress(R2))
      Serial.print(F("\r\nR2"));
      
    if(PS3.getButtonClick(R3))
      Serial.print(F("\r\nR3"));
    if(PS3.getButtonClick(L3))
      Serial.print(F("\r\nL3")); 

    if(PS3.getButtonClick(SELECT)) {
      Serial.print(F("\r\nSelect - ")); 
      PS3.setLedOff(LED1);delay(20);
      PS3.setLedOff(LED2);delay(20);
      PS3.setLedOff(LED3);delay(20);
      //PS3.setLedOn(LED4);
      status_rec=0;
      //Serial.print(PS3.getStatusString());        
    } 
    if(PS3.getButtonClick(START)) {
      Serial.print(F("\r\nStart"));              
      Serial.println(PS3.getStatusString());
    }
  delay(400);    
  }
  /*if(printAngle) {
    Serial.print(F("\r\nPitch: "));               
    Serial.print(PS3.getAngle(Pitch));                  
    Serial.print(F("\tRoll: ")); 
    Serial.print(PS3.getAngle(Roll)); 
    delay(100);    
  }*/
  for(int i=0;i<15;i++)
    {
    
    }
}
