/*
 Example sketch for the PS3 USB library - developed by Kristian Lauszus
 For more information visit my blog: http://blog.tkjelectronics.dk/ or 
 send me an e-mail:  kristianl@tkjelectronics.com
 */
#include <IRremote.h>
 //int RECV_PIN=2;
 //IRrecv irrecv(RECV_PIN);
 IRsend irsend;

#include <SoftwareSerial.h>
SoftwareSerial mySerial(4,5);

 
#define IR_T 0x2C9B      // T
#define IR_W 0x6C9B      // W
#define IR_PHOTO 0x8CBC0  // Photo
#define IR_REC 0xCBC0    // Rec/StopRec

int status_rec=0;


#include <PS3USB.h>
USB Usb;
/* You can create the instance of the class in two ways */
PS3USB PS3(&Usb); // This will just create the instance
//PS3USB PS3(&Usb,0x00,0x15,0x83,0x3D,0x0A,0x57); // This will also store the bluetooth address - this can be obtained from the dongle when running the sketch
Button Btarr[16]={UP,RIGHT,DOWN,LEFT,SELECT,START,L3,R3,L2,R2,L1,R1,TRIANGLE,CIRCLE,CROSS,SQUARE}; 
// Назначение кнопок
// 
//
//
//
//  5-START - отправить на irobot_create код 128


boolean printAngle;
uint8_t state = 0;

int status_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
long millis_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

void setup() {
  Serial.begin(115200);
  if (Usb.Init() == -1) {
    Serial.print(F("\r\nOSC did not start"));
    while(1); //halt
  }  
  Serial.print(F("\r\nPS3 USB Library Started"));

  mySerial.begin(57600);
  delay(2000);

}
void loop() {
  Usb.Task();

  if(PS3.PS3Connected || PS3.PS3NavigationConnected) 
  {
    if(PS3.getAnalogHat(LeftHatX) > 137 || PS3.getAnalogHat(LeftHatX) < 117 || PS3.getAnalogHat(LeftHatY) > 137 || PS3.getAnalogHat(LeftHatY) < 117 || PS3.getAnalogHat(RightHatX) > 137 || PS3.getAnalogHat(RightHatX) < 117 || PS3.getAnalogHat(RightHatY) > 137 || PS3.getAnalogHat(RightHatY) < 117) {
      Serial.print(F("\r\nLeftHatX: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatX));
      Serial.print(F("\tLeftHatY: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatY));
      if(!PS3.PS3NavigationConnected) {
        Serial.print(F("\tRightHatX: ")); 
        Serial.print(PS3.getAnalogHat(RightHatX));
        Serial.print(F("\tRightHatY: ")); 
        Serial.print(PS3.getAnalogHat(RightHatY));
       } 
    delay(300);   
    }
  // buttons
  for(int i=0;i<4;i++)
    {
    if(PS3.getButtonPress(Btarr[i]) && status_buttons[i]==0)
      {if(i==0)
          {mySerial.write((int)128);mySerial.write((int)131);}
       else if(i==1)
          {mySerial.write((int)139);mySerial.write((int)3);mySerial.write((int)255);mySerial.write((int)255);}
       else if(i==1)
          {mySerial.write((int)137);mySerial.write((byte)0);mySerial.write((int)10);mySerial.write((byte)0);mySerial.write((int)10);}
       else
          {mySerial.write((int)137);mySerial.write((byte)0);mySerial.write((byte)0);mySerial.write((byte)0);mySerial.write((byte)0);}
       Serial.println(i);   
       millis_buttons[i]=millis();status_buttons[i]=1;put_actions(i);} 
    else 
      {if(millis()-millis_buttons[i]>500) status_buttons[i]=0;} 
    }
  for(int i=4;i<16;i++)
    {
    if(PS3.getButtonPress(Btarr[i]) && status_buttons[i]==0)
      {Serial.println(i);
       millis_buttons[i]=millis();status_buttons[i]=1;
       put_actions(i);
       } 
    else 
      {if(millis()-millis_buttons[i]>2000) status_buttons[i]=0;} 
    }
  }
}

void put_actions(int btn1)
 {
 switch(btn1)
  {
  case 0: irsend.sendSony(IR_T,20);
       break;
  case 2: irsend.sendSony(IR_T,20);
       break;
  case 4: 
       PS3.setLedOff(LED1);delay(20);
       PS3.setLedOff(LED2);delay(20);
       PS3.setLedOff(LED3);delay(20);
       status_rec=0;
       break;
  case 12: irsend.sendSony(IR_PHOTO,20);
       break;
  case 14: irsend.sendSony(IR_REC,20);
       status_rec=1-status_rec;
       if(status_rec==1) PS3.setLedOn(LED3);
       else PS3.setLedOff(LED3);
       break;
  default: 
       break;
  }
 }
