/*
 Example sketch for the PS3 USB library - developed by Kristian Lauszus
 For more information visit my blog: http://blog.tkjelectronics.dk/ or 
 send me an e-mail:  kristianl@tkjelectronics.com
 */
#include <IRremote.h>
 //int RECV_PIN=2;
 //IRrecv irrecv(RECV_PIN);
 IRsend irsend;

#include <SoftwareSerial.h>
SoftwareSerial mySerial(4,5);

 
#define IR_T 0x2C9B      // T
#define IR_W 0x6C9B      // W
#define IR_PHOTO 0x8CBC0  // Photo
#define IR_REC 0xCBC0    // Rec/StopRec

int status_rec=0;


#include <PS3USB.h>
USB Usb;
/* You can create the instance of the class in two ways */
PS3USB PS3(&Usb); // This will just create the instance
//PS3USB PS3(&Usb,0x00,0x15,0x83,0x3D,0x0A,0x57); // This will also store the bluetooth address - this can be obtained from the dongle when running the sketch
Button Btarr[16]={UP,RIGHT,DOWN,LEFT,SELECT,START,L3,R3,L2,R2,L1,R1,TRIANGLE,CIRCLE,CROSS,SQUARE}; 
// Назначение кнопок
// 
//
//
//
//  5-START - отправить на irobot_create код 128

AnalogHat Joyarr[4]={LeftHatX,LeftHatY,RightHatX,RightHatY}; 


boolean printAngle;
uint8_t state = 0;

int status_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
long millis_buttons[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
long millis_buttons1[16]={500,500,500,500,2000,2000,2000,2000,2000,2000,2000,2000,2000,2000,2000,2000};

int status_joys[4]={0,0,0,0};
int millis_joys[4]={0,0,0,0};
int map_joys[4]={2000,-500,2000,-500};
int dHatLeft=0;
int dHatRight=0;

void setup() {
  Serial.begin(115200);
  if (Usb.Init() == -1) {
    Serial.print(F("\r\nOSC did not start"));
    while(1); //halt
  }  
  Serial.print(F("\r\nPS3 USB Library Started"));

  mySerial.begin(57600);
  delay(2000);
  mySerial.write((int)128);
  delay(1000);

}
void loop() {
  Usb.Task();

  //if(PS3.PS3Connected || PS3.PS3NavigationConnected) 
  //{
    //if(PS3.getAnalogHat(LeftHatX) > 132 || PS3.getAnalogHat(LeftHatX) < 124 || PS3.getAnalogHat(LeftHatY) > 132 || PS3.getAnalogHat(LeftHatY) < 124 || PS3.getAnalogHat(RightHatX) > 132 || PS3.getAnalogHat(RightHatX) < 124 || PS3.getAnalogHat(RightHatY) > 132 || PS3.getAnalogHat(RightHatY) < 124) {
      /*Serial.print(F("\r\nLeftHatX: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatX));
      Serial.print(F("\tLeftHatY: ")); 
      Serial.print(PS3.getAnalogHat(LeftHatY));
      //if(!PS3.PS3NavigationConnected) {
        Serial.print(F("\tRightHatX: ")); 
        Serial.print(PS3.getAnalogHat(RightHatX));
        Serial.print(F("\tRightHatY: ")); 
        Serial.print(PS3.getAnalogHat(RightHatY));
        Serial.println();
        int lr=map(PS3.getAnalogHat(RightHatX),0,255,-2000,2000);
        int fb=map(PS3.getAnalogHat(RightHatY),0,255,500,-500);
        Serial.print("lr="); 
        Serial.print(lr,DEC);
        Serial.print(" fb="); 
        Serial.print(fb,DEC);
        Serial.println();*/
    
   // joys
  for(int i=0;i<4;i++)
    {
    if((PS3.getAnalogHat(Joyarr[i]) != status_joys[i]) && (millis()-millis_joys[i]>200))
      {Serial.println(i+100);
       millis_joys[i]=millis();status_joys[i]=PS3.getAnalogHat(Joyarr[i]);
       int hat=map(PS3.getAnalogHat(Joyarr[i]),0,255,map_joys[i]*(-1),map_joys[i]);
       Serial.print("hat");Serial.print(i);Serial.print("="); 
       Serial.println(hat,DEC);
       if(i<2) dHatLeft=1;
       else dHatRight=1;
       } 
     } 
   if(dHatLeft>0) 
     {dHatLeft=0;}
   if(dHatRight>0)  
     {dHatRight=0;
      go_irobot(status_joys[3],status_joys[2]);} 
       //} 
    //delay(100);   
    //}
  // buttons
  for(int i=0;i<16;i++)
    {
    if(PS3.getButtonPress(Btarr[i]) && status_buttons[i]==0)
      {
       millis_buttons[i]=millis();status_buttons[i]=1;
       put_actions(i);
       } 
    else 
      {if(millis()-millis_buttons[i]>millis_buttons1[i]) status_buttons[i]=0;} 
    }
  //}
  //delay(200);
}

void put_actions(int btn1)
 {Serial.println(btn1);
 switch(btn1)
  {
  case 1: irsend.sendSony(IR_T,20);
      break;
  case 3: irsend.sendSony(IR_T,20);
       break;
  case 0: mySerial.write((int)145);mySerial.write((byte)0);mySerial.write((byte)0);
          mySerial.write((byte)0);mySerial.write((byte)0);
       break;
  case 2: mySerial.write((int)139);mySerial.write((int)8);mySerial.write((int)255);mySerial.write((int)255);
       break;
  case 4: mySerial.write(128);
       break;
  // start
  case 5: mySerial.write(131);
       break;
  case 12: irsend.sendSony(IR_PHOTO,20);
       break;
  case 14: irsend.sendSony(IR_REC,20);
       status_rec=1-status_rec;
       break;
  default: 
       break;
  }
 }
 
// отправка команд для движения робота
void go_irobot(int v1,int r1)
  {
   int v2,r2,lf1,rt1;
   if(v1<128 && r1<128)
      {lf1=v1+abs(r1-128)/2;rt1=max(0,v1-abs(r1-128)/2);}
   else if(v1<128 && r1>=128)
      {lf1=max(0,v1-abs(r1-128)/2);rt1=v1+abs(r1-128)/2;}
   else if(v1>=128 && r1<128)
      {lf1=v1-abs(r1-128)/2;rt1=min(255,v1+abs(r1-128)/2);}
   else if(v1>=128 && r1>=128)
      {lf1=min(255,v1+abs(r1-128)/2);rt1=v1-abs(r1-128)/2;}
   else
      ;
   //v2=map(v1,0,255,map_joys[3]*(-1),map_joys[3]);
   //r2=map(r1,0,255,map_joys[2]*(-1),map_joys[2]);
   lf1=map(lf1,0,255,250,-250);
   rt1=map(rt1,0,255,250,-250);
   Serial.print("go_irobot rad=");Serial.print(r1);Serial.print(" lf=");Serial.print(lf1);Serial.print("  rt=");Serial.println(rt1);
   mySerial.write(145);
   mySerial.write(highByte(rt1));mySerial.write(lowByte(rt1));
   mySerial.write(highByte(lf1));mySerial.write(lowByte(lf1)); 
  }
